Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Net
imports System.IO
imports System.Collections

Public Class ftp

#Region "varibili"

    ''' <summary>
    ''' Host FTP
    ''' </summary>
    Private _Host As String
    ''' <summary>
    ''' Username
    ''' </summary>
    Private _UserName As String
    ''' <summary>
    ''' Password
    ''' </summary>
    Private _Password As String

    ''' <summary>
    ''' Richiesta FTP
    ''' </summary>
    Private _FtpRequest As FtpWebRequest
    ''' <summary>
    ''' Risposta ftp
    ''' </summary>
    Private _FtpResponse As FtpWebResponse

    ''' <summary>
    ''' Flag SSL
    ''' </summary>
    Private _UseSSL As Boolean = False

#End Region

#Region "Propriet"

    ''' <summary>
    ''' FTP Host URI
    ''' </summary>
    Public Property Host() As String
        Get
            Return _Host
        End Get
        Set(ByVal value As String)
            _Host = value
        End Set
    End Property

    ''' <summary>
    ''' FTP User Name
    ''' </summary>
    Public Property UserName() As String
        Get
            Return _UserName
        End Get
        Set(ByVal value As String)
            _UserName = value
        End Set
    End Property

    ''' <summary>
    ''' FTP Password
    ''' </summary>
    Public Property Password() As String
        Get
            Return _Password
        End Get
        Set(ByVal value As String)
            _Password = value
        End Set
    End Property

    ''' <summary>
    ''' Flag utilizzo SSL
    ''' </summary>
    Public Property UseSSL() As Boolean
        Get
            Return _UseSSL
        End Get
        Set(ByVal value As Boolean)
            _UseSSL = value
        End Set
    End Property

#End Region

    Public Sub New()

    End Sub


    Public Function ListDirectory(ByVal path As String) As String
        If (path = Nothing Or path = "") Then
            path = "/"
        End If

        _FtpRequest = CType(WebRequest.Create("ftp://" + _Host + path), FtpWebRequest)

        _FtpRequest.Credentials = New NetworkCredential(_UserName, _Password)
        _FtpRequest.Method = WebRequestMethods.Ftp.ListDirectoryDetails

        _FtpRequest.EnableSsl = _UseSSL

        _FtpResponse = CType(_FtpRequest.GetResponse(), FtpWebResponse)

        Dim liststring As String = ""

        Try
            Dim sr As StreamReader = New StreamReader(_FtpResponse.GetResponseStream(), System.Text.Encoding.ASCII)
            liststring = sr.ReadToEnd()
            sr.Close()
        Catch ex As WebException
            Console.WriteLine(CType(ex.Response, FtpWebResponse).StatusDescription)
        End Try

        _FtpResponse.Close()

        Return liststring

    End Function


    Public Sub DownloadFile(ByVal Path As String, ByVal LocalPath As String, ByVal Name As String)

        Dim _fileName As String = LocalPath + "\" + Name

        Dim _File As FileInfo = New FileInfo(_fileName)
        Dim _FileStream As FileStream

        _FtpRequest = CType(WebRequest.Create("ftp://" + _Host + Path + Name), FtpWebRequest)

        _FtpRequest.Credentials = New NetworkCredential(_UserName, _Password)
        _FtpRequest.Method = WebRequestMethods.Ftp.DownloadFile

        _FtpRequest.EnableSsl = _UseSSL

        _FileStream = New FileStream(_File.FullName, FileMode.Create, FileAccess.Write)

        _FtpResponse = CType(_FtpRequest.GetResponse(), FtpWebResponse)

        Dim _ResponseStream As Stream = _FtpResponse.GetResponseStream()

        Dim buffer(1024) As Byte

        Dim bytesRead As Integer = _ResponseStream.Read(buffer, 0, 1024)

        While (bytesRead <> 0)
            _FileStream.Write(buffer, 0, bytesRead)
            bytesRead = _ResponseStream.Read(buffer, 0, 1024)
        End While

        _FileStream.Close()
        _ResponseStream.Close()

    End Sub


    Public Sub UploadFile(ByVal Path As String, ByVal LocalPath As String, ByVal Name As String)
        Dim _fileName As String = LocalPath + "\" + Name
        Dim _File As FileInfo = New FileInfo(_fileName)

        _FtpRequest = CType(WebRequest.Create("ftp://" + _Host + Path + Name), FtpWebRequest)

        _FtpRequest.Credentials = New NetworkCredential(_UserName, _Password)
        _FtpRequest.Method = WebRequestMethods.Ftp.UploadFile
        _FtpRequest.EnableSsl = _UseSSL

        Dim _fileContents(_File.Length) As Byte

        Dim fr As FileStream = _File.OpenRead()

        fr.Read(_fileContents, 0, Convert.ToInt32(_File.Length))

        fr.Close()

        Dim writer As Stream = _FtpRequest.GetRequestStream()

        writer.Write(_fileContents, 0, _fileContents.Length)
        writer.Close()
    End Sub

    Public Sub DeleteFile(ByVal Path As String, ByVal Name As String)
        _FtpRequest = CType(WebRequest.Create("ftp://" + _Host + Path + Name), FtpWebRequest)
        _FtpRequest.Credentials = New NetworkCredential(_UserName, _Password)
        _FtpRequest.Method = WebRequestMethods.Ftp.DeleteFile
        _FtpRequest.EnableSsl = _UseSSL

        _FtpResponse = CType(_FtpRequest.GetResponse(), FtpWebResponse)
        Dim _ResponseStream As Stream = _FtpResponse.GetResponseStream()
        _ResponseStream.Close()
    End Sub

    Public Sub ResumeDownloadFile(ByVal Path As String, ByVal LocalPath As String, ByVal Name As String)
        Dim _fileName As String = LocalPath + "\" + Name

        Dim _File As FileInfo = New FileInfo(_fileName)
        Dim _FileStream As FileStream

        _FtpRequest = CType(WebRequest.Create("ftp://" + _Host + Path + Name), FtpWebRequest)

        _FtpRequest.Credentials = New NetworkCredential(_UserName, _Password)
        _FtpRequest.Method = WebRequestMethods.Ftp.DownloadFile

        _FtpRequest.EnableSsl = _UseSSL


        If (_File.Exists) Then
            _FileStream = New FileStream(_File.FullName, FileMode.Append, FileAccess.Write)
        Else
            _FileStream = New FileStream(_File.FullName, FileMode.Create, FileAccess.Write)
        End If

        _FtpResponse = CType(_FtpRequest.GetResponse(), FtpWebResponse)

        Dim _ResponseStream As Stream = _FtpResponse.GetResponseStream()

        Dim buffer(1024) As Byte

        Dim bytesRead As Integer = _ResponseStream.Read(buffer, 0, 1024)

        While (bytesRead <> 0)
            _FileStream.Write(buffer, 0, bytesRead)
            bytesRead = _ResponseStream.Read(buffer, 0, 1024)
        End While

        _FileStream.Close()
        _ResponseStream.Close()

    End Sub



End Class
